#!/usr/bin/env python
#   #----- MODIFY pseudo_code_dict BY -----------
#   #----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#   #----- TO REAL pseudo_code ------------------
#   
#   ### THIS LINE IN THE TOP
#   from dttcmd import *
#
#   ### THESE LINES IN THE BOTTOM
#   self_func = []
#   for i in dir():
#       if callable(eval(i)): self_func.append(i)
#   
#   for i in pseudo_code_dict.keys():
#       p_list = pseudo_code_dict[i].sp_listit('\n')
#       for j in range(len(p_list)):
#           if '(' in p_list[j]:
#               if p_list[j].sp_listit('(',1)[0] in self_func:
#                   l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
#                   t = p_list[j][:l[-1]+1]
#                   p_list[j] = p_list[j].rep_listace(t, eval(t))
#       pseudo_code_dict[i] = '\n'.join(p_list)
#   

from dttcmd import *

from header_WareeSerif_Bold import *
#func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]
#
#cvt_dict = {
#    'evheight_lu' : 0,   #  -422
#    'tvheight_lu' : 0,   #  -422
#    'vbase' : 1,   #  0
#    'tvheight_num' : 2,   #  908
#    'evheight' : 3,   #  1062
#    'tvheight' : 4,   #  1140
#    'ecvheight' : 5,   #  1450
#    'tvheight_po' : 5,   #  1450
#    'estemtc' : 6,   #  218
#    'ecstemt' : 6,   #  218
#    'tstemtc' : 6,   #  218
#    'cvt_7' : 7,   #  130
#    'cvt_8' : 8,   #  139
#    'estemt' : 9,   #  207
#    'tstemt' : 9,   #  207
#    'estemw' : 10,   #  240
#    'tstemw' : 11,   #  240
#    'ecstemw' : 12,   #  253
#    'cvt_13' : 13,   #  233
#    'ecstemtc': 13,  #230
#    'cvt_14' : 14,   #  242
#    'cvt_15' : 15,   #  214
#    'cvt_16' : 16,   #  188
#    'sarastemw' : 16,   #  188
#    'stemwa' : 16,   #  188
#    'cvt_17' : 17,   #  216
#    'cvt_18' : 18,   #  210
#    'cvt_19' : 19,   #  175
#    'cvt_20' : 20,   #  177
#    'sarastemt':20,
#    'cvt_21' : 21,   #  231
#    'cvt_22' : 22,   #  113
#    'head_sara_stem' : 22,   #  113
#    'cvt_23' : 23,   #  133
##USER LAND
#    'tvheight_num_shoot' : 24,  # 908+24=932
#    'evheight_shoot' : 25,      # 1062+24=1086
#    'tvheight_shoot' : 26,      # 1140+24=1164
#    'ecvheight_shoot' : 27,     # 1450+27=1477
#    'headstem'  : 28,    # 140
#    'headdia'   : 29,    # 430
#    'headstemplushole' : 30,    # 290 
#    'estemwc'   : 31,   # 260
#    'ecstemwc'   : 32,   # 273
#    'vbase_shoot': 33,  #24
#    'tvbase_shoot': 33,  #24
#    'head_sara':    34, #360
#    }


#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#ds_headstemplushole = "15-4 16-4 17-2 18-6 19-2 20+2 21-2 24+4 28+4 29+4 30+4 32-4 33+4 34+4 38+8 "
ds_headstemplushole = ""
ds_headstem = "9-4 "
ds_headdia = "14+8 "
ds_head_sara_stem = "9-4 10-4 11-4 "
ds_head_sara = "14+8 15+8 23+8 24+8 "
ds_tnumheaddia = "9-8 10-4 "
ds_bighead = "9+4 10+4 11+4 "
ds_bighead_stem = ""
#DISABLE FOR BOLD
ds_tstemt = "9-1 10-1 11-1 12-1 13-1 14-1 15-1 16-1 "
ds_tstemt_thin = "9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 "
ds_tstemtc = ds_tstemrt = ds_tstemt
ds_tstemtc_thin = ds_tstemrt_thin = ds_tstemt_thin
ds_tstemtct = "17+3 18+3 "
ds_tstemtct_thin = "17+2 18+2 "

gen_cvt_func_dict = {
    #FOR UNROUNDED STEM
    #[min,black]
    #'mb':   ['estem*','tstem*','stem*','ecstem*'],
    #[min,black]
    'mb':   ['tnumstem*'],
    #[min,rnd,black]
    #'mrb':  ['headstem*','head_sara_stem','head_sara'],
    #
    #FOR ROUNDED STEM
    #[min,rnd,black]
    'mrb':  ['estem*','tstem*','stem*','ecstem*','headstem*','head_sara_stem','head_sara','sarastem*','wanstem*','serif*','tnumheaddia*','bighead*'],
    #[rp0,rnd,grey]
    '0rg':  ['headdia'],
    }

for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*':
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)
        
    for i in new_list:
        for j in ['1','1m','2','2m']:   #1=forward/bottomup, #2=reverse/topdown
            if j[-1] == 'm':    #m=move rp0
                cmd = 'mirp0'+arg
            else:
                cmd = 'mirp'+arg
            if j[0] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'
            #AUTO GENERATE delta string
            try:
                exec "a = ds_%s " % (i,)
            except:
                exec "ds_%s = ''" % (i,)

            #GEN FUNC
            exec '''def %s_%s(s,direction="%s"):
    return %s("%s",s,ds_%s,direction)
''' % (i,j,direction,cmd,i,i,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_thin
            if i in ['estemt','estemtc','tstemt','tstemtc','tstemrt','tstemtct']:
                #AUTO GENERATE delta string
                try:
                    exec "a = ds_%s_thin " % (i,)
                except:
                    #DEFAULT VALUE FOR 14,15,16 ppem
                    exec "ds_%s_thin = '14-2 15-2 16-2 '" % (i,)
                #GEN FUNC
                exec '''def %s_thin_%s(s,direction="%s"):
    return %s("%s",s,ds_%s_thin,direction)
''' % (i,j,direction,cmd,i,i,)


#EXAMPLE OF CVT FUNCTION DEFINED:
#
#def estemw_1(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw")
#   """
#
#def estemw_2(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw",direction="-")
#   """


#----------------------------------------
#DRY HEAD: KEEP HEAD OF CHARACTERS DRIED FOR 14,15,16 ppem
#ENABLE DRY HEAD FOR BOOK
ds_dryhead = "14+3 15+3 16+3 "
def dh1(*l): #dry head 
    d = {}
    for s in l:
        if s-1 < 0 or s+1 < 0:
            raise ValueError("ds value < 0: dh1(%s)" % (l,))
        d[s-1] = ds_dryhead
        d[s+1] = swap_dstr(ds_dryhead)
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15+4 16+3 17+3 18+3 ",
#        s+1: "15-4 16-3 17-3 18-3 " })

def dh2(*l): #dry head
    d = {}
    for s in l:
        if s-1 < 0 or s+1 < 0:
            raise ValueError("ds value < 0: dh2(%s)" % (l,))
        d[s-1] = swap_dstr(ds_dryhead)
        d[s+1] = ds_dryhead
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15-4 16-3 17-3 18-3 ",
#        s+1: "15+4 16+3 17+3 18+3 " })

def dh11(s): #dry 1 point +
    return f_dstr(s,ds_dryhead)

def dh12(s): #dry 1 point -
    return f_dstr(s,ds_dryhead,direction='-')

#DISABLE DRY HEAD FOR BOLD
#def dh1(*l):
#    return ""
#def dh2(*l):
#    return ""
#def dh11(s):
#    return ""
#def dh12(s):
#    return ""


ds_ud = "11+2 12+3 13+4 14+4 15+4 16+4 "
def ud1(s): #universal dry +
    return f_dstr(s,ds_ud)

def ud2(s): #universal dry -
    return f_dstr(s,ds_ud,direction='-')

ds_udx = "11+2 12+3 13+4 14+4 15+4 16+4 17+8 18+8 19+8 20+8 21+8 22+8 "
def udx1(s): #universal dry +
    return f_dstr(s,ds_udx)

def udx2(s): #universal dry -
    return f_dstr(s,ds_udx,direction='-')

#================================================
def evbc1(s,li=[]):
    return pl(""
        , mirp0rg("evbase_shoot",s)
        , f_ip(li)
        )

def tvbc(s,li=[]):  #thai vbase curve
    return pl(""
        , mirp0rg("tvbase_shoot",s)
        , f_ip(li)
        )

def tvblu(s,li=[]):
    return pl(""
        , mirprg("tvheight_lu",s)
        , f_ip(li)
        )

def tvblum(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_lu",s)
        , f_ip(li)
        )

def tvtc2(s,li=[],add1=""): #thai vtop curve
    return pl(""
        , mirp0rg("tvheight_shoot",s,"")
        , f_ip(li)
        , add1
        )

ds_vheight="9-8 31+8 "
def tvt2(s,li=[],move_rp0=False):
    if move_rp0:
        cmd = mirp0rg("tvheight",s,ds_vheight)
    else:
        cmd = mirprg("tvheight",s,ds_vheight)
    
    return pl(""
        #, 'SROUND 72', mirprg("tvheight",s), 'RTG'
        #, 'SROUND 73', mirprg("tvheight",s), 'RTG'
        #, 'SROUND 74', mirprg("tvheight",s), 'RTG'
        , 'SROUND 74', cmd, 'RTG'
        , f_ip(li)
        )

def tvt2m(s,li=[]):
    return tvt2(s,li,move_rp0=True)


def tvtpo(s,li=[]):
    return pl(""
        , mirprg("tvheight_po",s)
        , f_ip(li)
        )

def tvtpom(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_po",s)
        , f_ip(li)
        )

def thbsara(s):
    return mdapr(s)

def tvtsara(s):
    return mdapr(s,"11+8 16+8 ")

def tvtwanayuk(s):
    return mdapr(s,"14-8 ")


def tvtn(s, li=[]):
    return pl(""
        , 'SROUND 73', mirp0rg("tvheight_num",s,"21+8 "), 'RTG'
        , f_ip(li)
        )

def tvtnc(s, li=[]):
    return pl(""
        , mirp0rg("tvheight_num_shoot",s)
        , f_ip(li)
        )
#==================================================

def head_0(s,li,direction="+",dia="headdia", dsh_extra=""):
    #round head
    s,add1 = gen_alignrp(s)
    i1,addi1 = gen_alignrp(li[0],2)
    i2,addi2 = gen_alignrp(li[1],2)
    l = li[2:]
    reverse_dir = direction.replace('+','*').replace('-','+').replace('*','-')
    if dia == "head_sara":
        ds_dia = ds_head_sara
        stem = "head_sara_stem"
        ds_stem = ds_head_sara_stem
    elif dia == "bighead":
        ds_dia = ds_bighead
        stem = "bighead_stem"
        ds_stem = ds_bighead_stem
    else:
        ds_dia = ds_headdia
        stem = "headstem"
        ds_stem = ds_headstem
    if l:
        addip = f_ip(l)
    else:
        addip = ""
    if dsh_extra:
        add1_extra = f_dstr(s,dsh_extra)
    else:
        add1_extra = ""
    return pl(""
        , 'SROUND 3'
        , mirpmrb(stem,i1,ds_stem,direction)
        , addi1
        , 'SROUND 69'
        , mirp0rg(dia,s,ds_dia,direction)
        , add1_extra
        , add1
        , addip
        , 'SROUND 3'
        , mirpmrb(stem,i2,ds_stem,reverse_dir)
        , addi2
        , 'RTG'
        )

def head1(s,li,dsh_extra=""):
    #left to right
    return head_0(s,li,direction="+",dsh_extra=dsh_extra)

def head2(s,li,dsh_extra=""):
    #right to left
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dsh_extra=dsh_extra)

def headsara1(s,li,dsh_extra=""):
    return head_0(s,li,direction="+",dia="head_sara",dsh_extra=dsh_extra)

def headsara2(s,li,dsh_extra=""):
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dia="head_sara",dsh_extra=dsh_extra)

def bighead1(s,li,dsh_extra=""):
    return head_0(s,li,direction="+",dia="bighead",dsh_extra=dsh_extra)

def bighead2(s,li,dsh_extra=""):
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dia="bighead",dsh_extra=dsh_extra)



def xhead0(s2,s3,direction="+"):
    s2,add2 = gen_alignrp(s2,2)
    s3,add3 = gen_alignrp(s3,2)
    return pl(""
        , 'SROUND 3'
        , headstem_1(s2,direction=direction)
        , add2
        , 'RTDG', headstemplushole_1(s3,direction=direction)
        , add3
        , 'RTG'
        )


def xhead1(s1,s2,s3,dstr="14-8 ",direction="+"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , mdrp0mrg(s1,dstr)
        , add1
        , xhead0(s2,s3,direction)
        )

def xhead2(s1,s2,s3,dstr="13-8 ",direction="-"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , mdrp0rg(s1,dstr)
        , add1
        , xhead0(s2,s3,direction)
        )

def xhead2s(s1,s2,s3,dstr="",direction="-"):
    return xhead2(s1,s2,s3,dstr=dstr,direction=direction)

def xheadp1(s1,s2,s3,dstr="14-8 15-8 16-8 ",direction="+"):
    return xhead1(s1,s2,s3,dstr,direction)

#================================================
#new point reference
#f0,r0,...: use tuple to align multiple points

def trs_no_nu(r1,r2, h1,h2,li, r0):
    #thai rear stem of no nu
    return pl(""
        , mdapr(r0)
##book
#        , mdrp0mrw(h2,"10+8 11+8 13+8 ")
#        , head2(h1,li)
#        , f_dstr_dict({h1:"13-4", h2:"9+4 13-4 "})
##1#        , mdrp0rg(r1,"11-8 12-8 17-8 18-8 19-8 ")
##2#        , 'SROUND 73',ip_round(h1,h2,r1),'RTG'
##3#, 'SROUND 71', mdrp0rg(r1), 'RTG'
##4#, ip_round(h1,h2,r2), ip_round(h1,r2,r1), srp0(r1)
##        , tstemw_1(r2)
#        , ip_round(li[0],li[1],r2)
#        , tstemw_2(r1)
#bold
        , mdrp0mrw(h2,"9+4 10+4 11+4 ")
        , bighead2(h1,li)
        , ip_round(h1,h2,r1)
        , tstemw_1(r2)
        #, f_dstr(h2,"9+4 10-4 11-4 ")
        )

def trs_e(f1,f2, r1,i1,i2, r0):
    #sara e
    return pl(""
        , mdapr(r0)
        , mdrp0mrw(r1)
        , mdrp0rg(f1,"13+8 ")
        , tstemw_1(f2)
        , xhead2(r1,i1,i2)
        )

#================================================
def tx2_0(f0, f1,f2, r1,r2, r0, fstem='tstemw',rstem='tstemw',fround=70,rround=72,dsf="",dsr=""):
    #thai x-direction walk for 2 stem: ko_kai,
    return uxrs2(f0, f1,fstem,f2, r1,rstem,r2, r0, fround=fround, rround=rround,dsf=dsf,dsr=dsr)

def tx2_samphao(f0, h1,h2,h3, f1,f2, r1,r2, r0):
    #pho_samphao
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, dsf="14+8 ")
        , xheadp1(h1,h2,h3)
        )

def tx2_ko(f0, n1,n2, f1,f1f, f2,f2f, r1,r2, r0, rround=72):
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, rround=rround)
        , h_notch_ko(n1,n2, f1,f1f, f2,f2f)
        )

def tx2_khwai(f0, f1,f2, f3,f4,li34, f5,li5, r1,r2, r0):
    f3,add3 = gen_alignrp(f3)
    f4,add4 = gen_alignrp(f4)
    f5,add5 = gen_alignrp(f5)
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, fstem='tstemkw')
        , ip_round(f1,r1,f3)
        , add3
        , tstemw_1m(f4)
        , add4
        , f_ip([li34])
        , head1(f5,li5)
        , add5
        )


def tx2_1(f0, f1,f2,f3, f4,f5, r1,r2, r0, dsf="14+8 "):
    #thai x-direction walk for 2 stem: tho_thahan,
    fx4,temp = gen_alignrp(f4)
    return pl(""
        , tx2_0(f0, f4,f5, r1,r2, r0, fround=68, dsf=dsf)
        , srp0(fx4)
        , xhead1(f1,f2,f3)
        )

def tx2_2(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=70, dsf="",dsr=""):
    #thai x-direction walk for 2 stem: pho_phung
    fx1,temp = gen_alignrp(f1)
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, fround=fround, dsf=dsf, dsr=dsr)
        , srp0(fx1)
        , xhead2(f3,f4,f5)
        )

def tx2_2p(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=67, dsf="",dsr=""):
    return tx2_2(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=fround, dsf=dsf,dsr=dsr)

def tx2_3(f0, f1,f2,li12, f3,f4, f5,f6, r1,r2, r0, fround=70,rround=72, dsh_extra="",i56=-1,ds5=""):
    #kho_khai
    fx0,temp = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    fx3,temp = gen_alignrp(f3)
    f5,addf5 = gen_alignrp(f5)
    f6,addf6 = gen_alignrp(f6,2)
    rx1,temp = gen_alignrp(r1)
    if i56 >= 0:
        addi56 = f_ip([i56])
    else:
        addi56 = ""
    return pl(""
        , tx2_0(f0, f3,f4, r1,r2, r0, fround=fround,rround=rround)
        , ip_round(f0,fx3, f1)
        , addf1
        , head1(f2,li12,dsh_extra=dsh_extra)
        , 'SROUND 10'
        , ip_round(fx3,rx1,f5,ds5)
        , addf5
        , 'RTG'
        , mdrpg(f6)
        , addi56
        , addf6
        , f_dstr(f5,"14+2 15+2 16+2 ")
        )


def tx1(r1,r2, r0, rstem='tstemw',rround=71):
    #thai x-direction walk for 1 stem
    return uxrs1(r1,rstem,r2, r0, rround=rround)

def tx1_0(f0, f1, r1,r2, r0, rstem='tstemw', rround=71):
    #thai x-direction walk for 1 stem: ngo_ngu
    f0,addf0 = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    rx1,temp = gen_alignrp(r1)
    return pl(""
        , tx1(r1,r2, r0, rstem=rstem, rround=rround)
        , ip_round(f0,rx1, f1)
        )

def tx1_1(f0, f1,f2, r1, r0, fstem='tstemw', fround=72, rround=71):
    return uxrs1f(f0,f1,fstem,f2,r1,r0,fround,rround)



def tx3_0(f0, f1,f2, m1,m2, r1,r2, r0, fstem='tstemw',mstem='tstemw',rstem='tstemw',fround=70):
    #thai x-direction walk for 3 stem: cho_choe
    return uxrs3(f0, f1,fstem,f2, m1,mstem,m2, r1,rstem,r2, r0, fround=fround)


def txus2_0(f0, f1,f2, r1,r2, r0, fstem='tstemw',rstem='tstemw',fround=72,rround=70, dsf="",dsr=""):
    return uxus2(f0, f1,fstem,f2, r1,rstem,r2, r0, fround=fround,rround=rround,dsf=dsf,dsr=dsr)

#================================================

def h_notch_ko(s1,s2, s3,s3f, s4,s4f):
    return pl(""
        , srp0(s4)
        , serifw_1(s4f)
        , srp0(s3)
        , serifw_1(s3f)
        , mdrp0g(s1)
        #, mirpmb('ko_notch_w',s2)
        , mdrpmb(s2)
        )

def h_notch_samphao(s1,s2, s3, s4,s4f):
    return pl(""
        , srp0(s4)
        , serifw_1(s4f)
        , srp0(s3)
        , mdrp0g(s1)
        #, mirpmb('ko_notch_w',s2)
        , mdrpmb(s2)
        )

def v_notch_ko(s1,s2):
    s1,add1 = gen_alignrp(s1)
    s2,add2 = gen_alignrp(s2,2)
    return pl(""
        , 'SROUND 72',mdapr(s1),'RTG'
        , add1
        , tstemt_2(s2)
        , add2
        )

def v_head_kho_khai(s1,li1, s2, s3,s4, li4, add1=""):
    return pl(""
        , tvtc2(s1,li1)
        , add1
#book
        , tstemt_thin_2(s2)
        #, mdrp0rg(s3,"14+8 15+8 16+8 ")
        , mdrp0rg(s3)
        , head2(s4,li4)
#bold  
#        , tstemt_thin_2m(s2)
#        , mdrprg(s3)
#        , srp0(s1)
#        , mdrp0rg(s4,"19+8 ")
#        , xhead0(li4[0],li4[1])
        )

def v_head_kho_khuat(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6 , add1=""):
    return pl(""
        , tvtc2(s1, li1+[s6])
        , alignrp(s1s)
        , add1
        , 'RTDG'
        , tstemt_2(s2)
        , shprp2(s2s)
        , 'RUTG'
        , mdrp0mrg(s3,"9-8 10-8 ")
        , 'RTDG'
        , mdrprb(s4,"14-4 15-4 ")
        , 'RTG'
#book
        , srp0(s1)
        , mdrp0rg(s5)
        #, mdapr(s5,"14+8 15+8 16+8 ")
        , mdapr(s5)
        , head2(s6,li6)
#bold
#        , mdapr(s6)
#        , xhead0(li6[0],li6[1])
#        , srp0(li6[1])
#        , headstem_1(s5)
        )

def v_top_ko_kai(s1,li,s2, s3,s4):
    return pl(""
        , tvtc2(s1,li)
        , tstemtct_2(s2)
        , v_notch_ko(s3,s4)
        )

def v_top_kho_khwai(s1,li1,s2, s3,s4,li4,add1=""):
    s1,adds1 = gen_alignrp(s1)
    s4,adds4 = gen_alignrp(s4)
    return pl(""
        , tvtc2(s1,li1+[s3])
        , adds1
        , add1
        #, tstemtc_thin_2(s2)
        , tstemtct_thin_2(s2)
        , mdapr(s3,"9-8 ")
        , head2(s4,li4)
        , adds4
        )

def v_top_kho_khon(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6):
    return pl(""
        , tvtc2(s1,li1+[s5])
        , alignrp(s1s)
        , tstemtct_2(s2)
        , shprp2(s2s)
        , 'RUTG'
        , mdrp0rg(s3,"9-4 10-4 11-4 12-4 13-4 14-4 ")
        , 'RTG'
        , tstemtct_1(s4)
        , f_dstr(s4)
        , mdrp0mrw(s5)
        , mdapr(s5)
        , head2(s6,li6)
        )
        
def v_top_ro_rua0(s5, s2,s3,s4):
    return pl(""
        , alignrp(s5)
        , tstemtct_thin_2(s2)
        , 'RTDG'
        , mdrp0rg(s3)
        , 'RTG'
        , tstemtct_1(s4)
        )


def v_top_ro_rua(s1,li1, s2, s3,s4, s5):
    return pl(""
        , tvtc2(s1,li1)
        , v_top_ro_rua0(s5, s2,s3,s4)
        , srp0(s1)
        )

def h_dek(f1, s1,s2,li12, s3,s4,li34, r1, ds3="9+8 17+8 "):
    return pl(""
        , ip_round(f1,r1,s1)
        , tstemw_1(s2)
        , f_ip(li12)
        , ip_round(f1,r1,s3,ds3)
        , head1(s4,li34)
        )

def h_sara_i(r1,r2,r3,r4):
    return pl(""
        , thbsara(r1)
        , bighead_stem_2(r2)
        , mdrp0rg(r4)
        , bighead_stem_1(r3)
        )

def v_sara_i(s1,s2,li12, s3,s4):
    return pl(""
        , tvtsara(s1)
        , 'RTDG',mdrp0rg(s2),'RTG'
        , f_ip(li12)
        , mdrp0mrw(s3)
        , mdapr(s3)
        #, tstemtct_1m(s4)
        , mdrp0mrg(s4)
        )

#================================================
pseudo_code_dict = {

    'uni0E01':      #KO KAI
        packline(""
        , tx2_ko(27, 19,8, 15,18,13,10, 1,25, 28)
        , add_ip(19,25,[22,5])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , alignrp(14)
        , v_top_ko_kai(22,[8,2,25], 5, 8,(19,10))
        , iy()
        ),

    'uni0E02':    #KHO KHAI
        packline(""
        , tx2_3(54, 24,18,[51,45,13], 3,33, 7,30, 37,39, 55)
        , ud2(13)
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(34)
        , tvt2(38)
        , v_head_kho_khai(27,[7,30,4,33], 10, 13,21,[42,48])
        , iy()
        , dh2(18)
        ),

    'uni0E03':    #KHO KHUAT
        packline(""
        , tx2_3(54, 24,18,[51,45,13], 3,33, 7,30, 37,39, 55, dsh_extra="",ds5="9+4 10+4 11+4 12+4 ")
        , add_ip(24,30, [26,27,28, 9,10,11])
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(34)
        , tvt2(39)
        , v_head_kho_khuat(28,26,[7,30,4,33], 9,11, 10,27, 13,21,[42,48])
        , iy()
        , dh2(18)
        ),

    'uni0E04':    #KHO KHWAI
        packline(""
        , tx2_khwai(48, 29,8, 25,23,11, 17,[45,39], 1,35, 49)
        , add_ip(29,35,[32,5])
        , ix()
        , dh1(14)
        , dh2(20)
        #y
        , sy()
        , mdapr(1)
        , alignrp(24)
        , v_top_kho_khwai(32,[29,8,26,11,2,35], 5, 14,20,[36,42,23])
        , ud2(11)
        , iy()
        , dh2(17)
        , dh11(22)
        ),

    'uni0E05':    #KHO KHON
        packline(""
        , tx2_khwai(48, 29,8, 25,23,11, 17,[45,39], 1,35, 49)
        , add_ip(29,35,[31,32,33,4,5,6])
        , ix()
        , dh1(14)
        , dh2(20)
        #y
        , sy()
        , mdapr(1)
        , alignrp(24)
        , v_top_kho_khon(33,31,[29,8,26,11,2,35], 4,6, 5,32, 14,20,[36,42,23])
        , ud2(11)
        , iy()
        , dh2(17)
        ),

    'uni0E06':    #KHO RAKHANG
        packline(""
        , tx2_3(77, 35,29,[64,58,24], (14,69),(44,3), 18,41, 50,52, 78, dsh_extra="")
        , add_ip(35,41,[37,38,39,20,21,22])
        , add_ip(44,50,[47,48,1])
        , srp0(14)
        , mdrp0rg(9,"14-8 ")
        , headstem_1(74)
        , ix()
        , dh1(26,12)
        , dh2(32,6)
        #y
        , sy()
        , mdapr(1)
        , tstemtm_1(47)
        , tvt2(52)
        , v_head_kho_khuat(39,37,[18,41,15,44,], 20,22, 21,38, 24,32,[55,61])
        , srp0(1)
        , tvbc(6)
        , headstemt_1(67)
        , mdrp0rg(12)
        , f_ip([45,3])
        , headstem_2(71)
        , ud1(3)
        , iy()
        , dh2(29)
        , dh1(9)
        ),

    'uni0E07':    #NGO NGU
        packline(""
        , tx1_0(34, 2, 7,19, 35)
        , add_ip(2,7,[3,1,0,5])
        , srp0(7)
        , xhead1(13,31,25)
        , srp0(1)
#        , mirpb('tstemkw',4,"14-4 15-3 16-2 ")
        , mdrpb(4)
        , ix()
        , dh1(16)
        , dh2(10)
        #y
        , sy()
        , mdapr(1)
        , tstemtm_1(4)
        , tvtc2(16,[3])
        , head2(10,[22,28])
        , mdapr(3)
        , mdrpg(2)
        , iy()
        , dh1(13)
        ),

    'uni0E08':    #CHO CHAN
        packline(""
        , tx2_0(53, 3,15, 22,37, 54)
        , ip_round(53,3,30)
        , srp0(3)
        , xhead1(9,50,44)
        , add_ip(30,37,[34,26])
        , add_ip(3,37,[19,0])
        , ix()
        , dh1(12)
        , dh2(6)
        #y
        , sy()
        , mdapr(53)
        , tvtc2(34,[30,23,37])
        , tstemtc_2(26)
        , mdapr(30)
        , mdrp0mrw(12)
        , head2(6,[41,47])
        , srp0(53)
        , tvbc(0)
        , tstemtc_1(19)
        , iy()
        , dh1(9)
        ),

    'uni0E09':    #CHO CHING
        packline(""
        , trs_no_nu(16,31, 43,37,[68,62], 72)
        , iprs_front_stem(71, 1,'tstemw',(13,0), 31, dsf="14+8 ")
        , xhead1(7,56,50)
        , ip_round(71,1,24)
        , add_ip(24,31,[28,20])
        , ix()
        , dh1(10)
        , dh2(4,40)
        #y
        , sy()
        , mdapr(0)
        , tstemt_1(14)
        , tvtc2(28,[17,31,10])
        , tstemtc_2(20)
        , mdapr(10,"9-8 ")
        , mdrpmrw(24)
        , head2(4,[47,53])
        , srp0(0)
        , tvbc(40)
        , bighead1(33,[59,65,45,16])
        , iy()
        , dh1(7,43)
        , dh2(37)
        ),

    'uni0E0A':    #CHO CHANG
        packline(""
        , tx2_3(66, 24,18,[63,57,13], 3,52, 7,49, 46,40, 67, i56=30)
        , srp0(49)
        , mdrpg(37)
        , srp0(46)
        , mdrp0mrg(33)
        , tstemw_1(34)
        , ud2(13)
        , ud2(37)
        , ix()
        , dh2(15)
        , dh1(21)
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(53)
        , v_head_kho_khai(27,[7,30,49,37,4,52,46,40], 10, 13,21,[54,60], add1=mdrpmrg(34))
        , iy()
        , dh2(18)
        ),

    'uni0E0B':    #SO SO
        packline(""
        , tx2_3(66, 24,18,[63,57,13], 3,52, 7,49, 46,40, 67, dsh_extra="", i56=30,ds5="9+4 10+4 11+4 12+4 ")
        , add_ip(24,49, [26,27,28,9,10,11])
        , srp0(49)
        , mdrpg(37)
        , srp0(46)
        , mdrp0mrg(33)
        , tstemw_1(34)
        , ud2(13)
        , ud2(37)
        , ix()
        , dh1(15)
        , dh2(21)
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(53)
        , v_head_kho_khuat(28,26,[7,30,49,37,4,52,46,40], 9,11, 10,27, 13,21,[54,60], add1=mdrpmrg(34))
        , iy()
        , dh2(18)
        ),

    'uni0E0C':    #CHO_CHOE
        packline(""
        , tx3_0(77, 38,26, (14,69),(48,3), 51,53, 78)
        , h_notch_ko(42,21, 38,41, 27,23)
        , srp0(38)
        , xhead2s(32,57,63, dstr="")
        , srp0(14)
        , mdrp0rg(9)
        , headstem_1(75)
        #
        , add_ip(42,58,[45,18])
        , ix()
        , dh1(30,12)
        , dh2(35,6)
        #y
        , sy()
        , mdapr(1)
        , tvt2(53)
        , v_top_ko_kai(45,[39,26,15,48,51],18, 21,(42,23))
        , srp0(1)
        , tvbc(35)
        , alignrp(6)
        , head1(27,[54,60])
        , srp0(6)
        , bighead_stem_1(66)
        , 'RTDG',mdrp0rg(12),'RTG'
        , f_ip([49,3])
        , headstem_2(72)
        , ud1(3)
        , iy()
        , dh1(9)
        , dh2(32)
        ),

    'uni0E0D.descless':    #YO YING
        packline(""
        , tx3_0(62, 27,15, 3,37, 44,46, 63)
        , h_notch_ko(31,10, 27,30, 15,12)
        , srp0(27)
        , xhead2s(21,53,59)
        #
        , add_ip(31,37,[34,7])
        , ix()
        , dh1(18)
        , dh2(24)
        #y
        , sy()
        , mdapr(62)
        , tvt2(46)
        , v_top_ko_kai(34,[28,15,4,37,10], 7, 10,(31,12))
        , srp0(62)
        , tvbc(24)
        , alignrp(0)
        , tstemtc_1(41)
        , head1(16,[50,56])
        , iy()
        , dh2(21)
        ),

    'desc.uni0E0D':
        packline(""
        , mdapr(18)
        , mdrpb(17)
        , mdrp0rg(3)
        , mdrprg(9)
        , f_ip([30,24,12])
        , ix()
        #y
        , sy()
        , mdapr(33)
        , mdrp0mrw(6)
        , mdrprg(18)
        , mdrp0rg(0)
        , f_ip([27,21])
        , mdrpg(14)
        , iy()
        ),

    'uni0E0E':    #DO CHADA
        packline(""
        , tx2_samphao(74, 37,61,55, 42,30, (20,1),50, 75)
        , h_notch_samphao(44,27, 42, 30,29)
        , srp0(1)
        , mdrprg(66)
        , f_ip([13,18,3])
        , mdrp0rg(8)
        , headstem_1(71)
        , add_ip(44,50,[47,24])
        , dx(66,8)
        , dx(18,-8)
        , ix()
        , dh1(40,11)
        , dh2(34,5)
        #y
        , sy()
        , mdapr(74)
        , v_top_ko_kai(47,[27,21,50], 24, 27,(44,29))
        , srp0(74)
        , tvbc(34)
        , head1(42,[52,58])
        , srp0(74)
        , tvblum(1)
        , mdrpg(20)
        , mdrp0rg(5)
        , head1(11,[64,68, 13,66,18,3,20])
#
        , dx(3,8)
        , dx(13,-8)
        , iy()
        , dh1(37,8)
        ),

    'uni0E0F':    #TO PATAK
        packline(""
        , tx2_samphao(78, 41,65,59, 46,34, (24,1),54, 79)
        , h_notch_samphao(48,31, 46, 34,33)
        , srp0(24)
        , mdrprg(70)
        , f_ip([15,20,5,21,2])
        , mdrp0rg(10)
        , headstem_1(75)
        , add_ip(48,54,[51,28])
        , dx(70,8)
        , dx(20,-8)
        , ix()
        , dh1(44,13)
        , dh2(38,7)
        #y
        , sy()
        , mdapr(78)
        , v_top_ko_kai(51,[31,25,54], 28, 31,(48,33))
        , srp0(78)
        , tvbc(38)
        , head1(46,[56,62])
        , srp0(78)
        , tvblum(7)
        , alignrp(4)
        , alignrp(1)
        , mdrpg(24)
        , head1(13,[68,72, 15,70,20,5,22,21,2])
#
        , dx(5,8)
        , dx(15,-8)
        , iy()
        , dh1(41,10)
        ),

    'uni0E10.descless':    #THO THAN
        packline(""
        , tx2_0(68, 3,15, 22,52, 69)
        , xhead1(9,65,59)
        , ip_round(68,3,26)
        , tstemkw_1(49)
        , ip_round(52,69,38)
        , mdrpg(37)
        , add_ip(26,38,[29,34,46,41])
        , ud2(49)
        , ix()
        , dh1(12)
        , dh2(6)
        #y
        , sy()
        , mdapr(68)
        , v_top_ro_rua(29,[12,26,49,50,23,52], 46, 41,34, 37)
        , srp0(50)
        , tstemt_2(25)
        , mdapr(12)
        , head2(6,[56,62])
        , srp0(68)
        , tvbc(0)
        , tstemtc_1(19)
        , iy()
        , dh1(9)
        ),

    'desc.uni0E10':
        packline(""
        , mdapr(36)
        , mdrpmrb(24)
        , mdrprg(30)
        , f_ip([48,42])
        , mdrp0rg(20)
        , f_ip([21,22,1,2,4])
        , mdrprg(10)
        , f_ip([58,53,15,5])
        , ix()
        #y
        , sy()
        , mdapr(61)
        , mdrp0mrw(33)
        , mdrp0rg(27)
        , f_ip([45,39])
        , mdrp0rg(1)
        , alignrp(4)
        , alignrp(7)
        , mdrpmrb(24)
        , shprp2(21)
        , mdrprg(13)
        , f_ip([51,55,5,15,21,2,22])
        , iy()
        ),

   'uni0E11':    #THO NANGMONTHO
        packline(""
        , tx2_3(57, 29,23,[54,48,18], 8,(38,7), 12,35, 1,44, 58, dsh_extra="", ds5="9+4 10+4 11+4 12+4 ")
        , add_ip(29,35, [31,32,33, 14,15,16])
        , add_ip(8,1,[40])
        , srp0(40)
        , mdrpg(6)
        , ix()
        , dh1(20)
        , dh2(26)
        #y
        , sy()
        , mdapr(1)
        , alignrp(7)
        , v_head_kho_khuat(33,31,[12,35,9,38,39,2,44], 14,16, 15,32, 18,26,[45,51], add1=pl( alignrp(42), tstemtct_2(4)))
        , ud2(39)
        , iy()
        , dh2(23)
        ),

    'uni0E12':    #THO PHUTHAO
        packline(""
        , tx3_0(88, 52,21, (14,79),(58,3), 61,63, 89, fstem='tstemkw')
        , h_dek(52, 46,44,[27], 33,39,[73,67,30], 14, ds3="")
        , srp0(14)
        , mdrp0rg(9)
        , headstem_1(85)
#
        , add_ip(52,58,[54,55,56, 17,18,19])
        , ix()
        , dh1(36,12)
        , dh2(6)
        , dh11(31)
        #y
        , sy()
        , mdapr(1)
        , alignrp(45)
        , tvt2(63)
        , v_top_kho_khon(56,54,[61,52,21,15,58,27,44], 17,19, 18,55, 36,30,[64,70])
        , srp0(1)
        , tvbc(6)
        , bighead_stem_1(76)
        , mdrp0rg(12)
        , f_ip([59,3])
        , headstem_2(82)
        , ud2(27)
        , ud1(3)
        , iy()
        , dh1(33,9)
        , dh2(39)
        ),

    'uni0E13':    #NO NEN
        packline(""
        , trs_no_nu(38,40, 52,46,[77,71], 81)
        , iprs_front_stem(80, 25,'tstemw',13, 38)
        , xhead2s(19,59,65)
        , h_notch_ko(29,8, 25,28, 13,10)
        , iprs_middle_stem(25, 1,'tstemw',(35,0), 38)
        , add_ip(29,35,[32,5])
        , ix()
        , dh1(16)
        , dh2(22,49)
        , dh12(43)
        #y  
        , sy()
        , mdapr(1)
        , tvt2(40)
        , v_top_ko_kai(32,[36,8,26,13,2,35], 5, 8,(29,10))
        , srp0(1)
        , tvbc(22)
        , alignrp(49)
        , head1(14,[56,62])
        , srp0(49)
        , bighead1(42,[68,74,54,38])
        , ud1(54)
        , iy()
        , dh2(19,46)
        , dh1(52)
        ),

    'uni0E14':    #DO DEK
        packline(""
        , tx2_0(58, 39,8, 1,45, 59, fstem='tstemkw')
        , h_dek(39, 33,31,[14], 20,26,[55,49,17], 1)
        , add_ip(39,45,[42,5])
        , ix()
        , dh1(23)
        , dh11(18)
        #y
        , sy()
        , mdapr(1)
        , alignrp(32)
        , v_top_kho_khwai(42,[39,8,14,31,2,45], 5, 23,17,[46,52])
        , ud2(14)
        , iy()
        , dh1(20)
        , dh2(26)
        ),

    'uni0E15':    #TO TAO
        packline(""
        , tx2_0(58, 39,8, 1,45, 59, fstem='tstemkw')
        , h_dek(39, 33,31,[14], 20,26,[55,49,17], 1)
        , add_ip(43,45,[41,42,43, 4,5,6])
        , ix()
        , dh1(23)
        , dh11(18)
        #y
        , sy()
        , mdapr(1)
        , alignrp(32)
        , v_top_kho_khon(43,41,[39,8,14,31,2,45], 4,6, 5,42, 23,17,[46,52])
        , ud2(14)
        , iy()
        , dh1(20)
        , dh2(26)
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , tx2_ko(49, 29,8, 25,28,13,10, 1,35, 50)
        , srp0(25)
        , xhead2(19,40,46)
        , ix()
        , dh1(16)
        , dh2(22)
        #y
        , sy()
        , mdapr(1)
        , v_top_ko_kai(32,[8,26,13,2,35], 5, 8,(29,10))
        , srp0(1)
        , tvbc(22)
        , head1(16,[37,43])
        , iy()
        , dh2(19)
        ),

    'uni0E17':      #THO THAHAN
        packline(""
        , tx2_1(39, 14,36,30, 8,(20,7), 1,26, 40, dsf="")
        , add_ip(8,1,[22])
        , srp0(22)
        , mdrpg(6) 
        , ix()
        , dh1(17)
        , dh2(11)
        #y
        , sy()
        , mdapr(1)
        , alignrp(7)
        , tvtc2(17,[22,6,2,26])
        , alignrp(24)
        , tstemtc_2(4)
        , head2(11,[27,33])
        , ud2(21)
        , iy()
        , dh1(15)
        ),

    'uni0E18':      #THO THONG
        packline(""
        , tx2_0(47, (3,43),(41,28), 37,32, 48, rround=74)
        #, 'RTDG',ip_round(47,3,5),'RTG'
        , mdrp0g(5)
        , tstemkw_1(46)
        , ip_round(32,48,17)
        , add_ip(5,17,[8,25,13,20])
        , ud2(46)
        , ix()
        #y
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(42)
        , v_top_ro_rua(8,[5,46,44,2,43,29,4,41,30,38,32], 25, 20,13, 16)
        , srp0(30)
        , tstemt_2(40)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
        , trs_no_nu(16,18, 30,24,[55,49], 59)
        , iprs_front_stem(58, 1,'tstemw',(13,0), 16, fround=70, dsf="14+8 ")
        , xhead1(7,43,37)
        , ix()
        , dh1(10)
        , dh12(21)
        , dh2(4,27)
        #y
        , sy()
        , mdapr(0)
        , tvt2(18)
        , tvtc2(10,[14])
        , head2(4,[34,40])
        , srp0(0)
        , tvbc(27)
        , bighead1(20,[46,52,32,16])
        , ud1(32)
        , iy()
        , dh1(7,30)
        , dh2(24)
        ),  

    'uni0E1A':      #BO BAIMAI
        packline(""
        , tx2_1(36, 9,33,27, 3,15, 19,21, 37)
        , srp0(3)
        , serifw_2(1)
        , ix()
        , dh1(12)
        , dh2(6)
        #y  
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(16)
        , tvt2(21)
        , tvtc2(12)
        , head2(6,[24,30])
        , iy()
        , dh1(9)
        ),

    'uni0E1B':      #PO PLA
        packline(""
        , tx2_1(36, 9,33,27, 3,15, 19,21, 37)
        , srp0(3)
        , serifw_2(1)
        , ix()
        , dh1(12)
        , dh2(6)
        #y  
        , sy()
        , mdapr(1)
        , tstemt_1(2)
        , shprp2(16)
        , tvtpo(21)
        , tvtc2(12)
        , head2(6,[24,30])
        , iy()
        , dh1(9)
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , tx2_2p(37, 6,(18,4), 13,28,34, (21,1),23, 38)
        , add_ip(18,21,[20,3])
        , ix()
        , dh1(10)
        , dh2(16)
        #y  
        , sy()
        , mdapr(1)
        , alignrp(5)
        , tvt2(23)
        , tvtc2(10,[2,3,4,19,20,21])
        , head2(16,[25,31])
        , ud1(3)
        , iy()
        , dh2(13)
        ),  

    'uni0E1D':      #FO FA
        packline(""
        , tx2_2p(37, 6,(18,4), 13,28,34, (21,1),23, 38)
        , add_ip(18,21,[20,3])
        , ix()
        , dh1(10)
        , dh2(16)
        #y  
        , sy()
        , mdapr(1)
        , alignrp(5)
        , tvtpo(23)
        , tvtc2(10,[2,3,4,19,20,21])
        , head2(16,[25,31])
        , ud1(3)
        , iy()
        , dh2(13)
        ),  

    'uni0E1E':      #PHO PHAN
        packline(""
        , tx2_1(35, 10,32,26, 4,(16,3), (20,1),22, 36)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdapr(1)
        , alignrp(3)
        , tvt2(22)
        , tvtc2(13,[2,17,18,19])
        , head2(7,[23,29])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh1(10)
        ),

    'uni0E1F':      #FO FAN
        packline(""
        , tx2_1(35, 10,32,26, 4,(16,3), (20,1),22, 36)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdapr(1)
        , alignrp(3)
        , tvtpo(22)
        , tvtc2(13,[2,17,18,19])
        , head2(7,[23,29])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , iy()
        , dh1(10)
        ),

    'uni0E20':    #PHO SAMPHAO
        packline(""
        , tx2_samphao(45, 18,42,36, 23,11, 1,31, 46)
        , h_notch_samphao(25,8, 23, 11,10)
        , add_ip(25,31,[28,5])
        , ix()
        , dh1(21)
        , dh2(15)
        #y
        , sy()
        , mdapr(1)
        , v_top_ko_kai(28,[8,2,31], 5, 8,(25,10))
        , srp0(1)
        , tvbc(15)
        , head1(23,[33,39])
        , iy()
        , dh1(18)
        ),

    'uni0E21':      #MO MA
        packline(""
        , tx2_1(60, (20,9),(45,57),39, (14,51),(26,3), 31,33, 61, dsf="")
        , add_ip(14,31,[1])
        , srp0(1)
        , mdrpg(29)
        , ix()
        , dh1(23,12)
        , dh2(17,6)
        #y
        , sy()
        , mdapr(1)
        , tvt2(33)
        , tvtc2(23,[29])
        , head2(17,[36,42])
        , srp0(1)
        , tvbc(6)
        , bighead_stem_1(48)
        , mdrp0rg(12)
        , f_ip([27,3])
        , headstem_2(54)
        , ud1(3)
        , iy()
        , dh1(20,9)
        ),
    
    'uni0E22':    #YO YAK
        packline(""
        , tx2_0(56, 3,31, 38,40, 57)
        , srp0(3)
        , mdrprg(27)
        , f_ip([7])
        , mdrp0rg(10)
        , tstemw_1(22)
        , xhead2(16,47,53,dstr="12-8 ")
        , ud1(7)
        , ix()
        , dh1(13)
        , dh2(19)
        #y
        , sy()
        , mdapr(56)
        , tvbc(0)
        , tstemtc_1(35)
        , tvt2(40)
        , tvtc2(13,[26])
        , head2(19,[44,50,22])
        , 'SROUND 70',mdapr(26),'RTG'
        , tstemt_2(27)
        , f_ip([7])
        , f_dstr(22,"16+7 ")
        , iy()
        , dh2(16)
        ),

    'uni0E23':    #RO RUA
        packline(""
        , tx2_0(54, 12,35, 8,38, 55, fstem='tstemtct',rround=73)
        , srp0(8)
        , xhead1(3,51,45)
        , ip_round(38,55,24)
        , add_ip(12,24,[15,32,20,27])
        , ud2(35)
        , ix() 
        , dh1(6)
        , dh11(1), dh12(41)
        #y
        , sy() 
        , mdapr(54)
        , v_top_ro_rua(15,[12,35,36,9,38], 32, 27,20, 23)
        , srp0(36)
        , tstemt_2(11)
        , srp0(54)
        , tvbc(0)
        , head1(6,[42,48])
        , iy()
        , dh1(3)
        ),  

    'uni0E24':      #RU
        packline(""
        , tx2_ko(49, 29,8, 25,28,13,10, 1,35, 50)
        , srp0(25)
        , xhead2(19,40,46)
        , ix()
        , dh1(16)
        , dh2(22)
        #y
        , sy()
        , mdapr(49)
        , tvtc2(32,[8,26,13,2,35])
        , tstemtc_2(5)
        , v_notch_ko(8,(29,10))
        , srp0(49)
        , tvbc(22) 
        , head1(16,[37,43])
        , srp0(49)
        , tvblu(1)
        , iy()
        , dh2(19)
        ),

    'uni0E25':      #LO LING
        packline(""
        , tx2_2p(55, 20,8, 14,46,52, (1,27),42, 56, fround=70)
        , ip_round(55,8,35)
        , add_ip(35,42,[39,31])
        , add_ip(20,27,[24,5])
        , ix()
        , dh1(11)
        , dh2(17)
        #y
        , sy()
        , mdapr(1)
        , tvtc2(39,[21,8,35,24,27,2,28,42])
        , tstemtc_2(31)
        , mdapr(35)
        , mdapr(24,"9-8 ")
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(17)
        , head1(11,[43,49])
        , ud2(27)
        , iy()
        , dh2(14)
        ),

    'uni0E26':    #LU
        packline(""
        , tx2_0(45, 23,11, 1,31, 46)
        , xheadp1(18,42,36)
        , h_notch_samphao(25,8, 23, 11,10)
        , add_ip(25,31,[28,5])
        , ix()
        , dh1(21)
        , dh2(15)
        #y
        , sy()
        , mdapr(45)
        , tvtc2(28,[8,2,31])
        , tstemtc_2(5) 
        , v_notch_ko(8,(25,10))
        , srp0(45)
        , tvbc(15)
        , head1(21,[33,39])
        , srp0(45)
        , tvblu(1)
        , iy()
        , dh1(18)
        ),

    'uni0E27':    #WO WAEN
        packline(""
        , tx1_0(39, 16, 8,23, 40)
        , srp0(8)
        , xhead1(3,36,30)
        , add_ip(16,23,[20,12])
        , ix()
        , dh1(6)
        , dh11(1), dh12(26)
        #y
        , sy()
        , mdapr(39)
        , tvtc2(20,[16,9,23])
        , tstemt_2(12)
        , mdapr(16)
        , srp0(39)
        , tvbc(0)
        , head1(6,[27,33])
        , iy()
        , dh1(3)
        ),  

    'uni0E28':    #SO SALA
        packline(""
        , tx2_khwai(60, 20,45, 16,14,33, 8,[57,51], 1,32, 61)
        , add_ip(20,32,[23,42,25,40,30,4])
        , add_ip(14,8,[38,6])
        , srp0(32)
        , mdrp0mrg(28)
        , tstemw_2(27)
        , dx(40,16)
        , dx(30,-8)
        , ud1(40)
        , ix()
        , dh1(36)
        , dh2(11)
        #y
        , sy()
        , mdapr(1)
        , alignrp(15)
        , v_top_kho_khwai(23,[20,45,17,33,25,40,30,4,2,32], 42, 36,11,[48,54,6,38,14], add1=mdrpmrg(28))
        , ud2(33)
        , dx(25,-8)
        , dx(4,8)
        , iy()
        , dh2(8)
        , dh11(13)
        ),


    'uni0E29':      #SO RUSI
        packline(""
        , tx2_1(67, 9,64,58, 3,(15,53), (46,36),(41,38), 68)
        , srp0(3) 
        , serifw_2(1)
        , ip_round(15,46,22)
        , add_ip(53,22,[30,24])
        , ix()
        , dh1(12)
        , dh2(6)
        #y  
        , sy()
        , mdapr(1) 
        , tstemt_1(2)
        , shprp2(54)
        , tvt2(38)
        , tvtc2(12,[19])
        , head2(6,[55,61])
        , mdapr(19)
        , mdrprg(50)
        , f_ip([28,33,16,53,36,47,39,41])
        , iy()
        , dh1(9)
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , tx2_2p(66, 20,8, 14,57,63, (1,46),45, 67, fround=70)
        , ip_round(66,8,32)
        , add_ip(32,45,[36,28,38,26,43,49])
        , add_ip(20,46,[24,5,51])
        , srp0(45)
        , mdrp0mrw(41)
        , tstemw_2(40)
        , dx(26,16)
        , dx(43,-8)
        , ud1(26)
        , ix()
        , dh1(11)
        , dh2(17)
        #y
        , sy()
        , mdapr(1)
        , tvtc2(36,[21,8,32,24,46,2,47,45,38,26,43,49], add1=mdrpmrg(41))
        , tstemtc_2(28)
        , mdapr(32)
        , mdapr(24,"9-8 ")
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(17)
        , head1(11,[54,60])
        , ud2(46)
        , dx(50,8)
        , dx(38,-8)
        , iy()
        , dh2(14)
        ),

    'uni0E2B':      #HO HIP
        packline(""
        , tx2_1(63, 15,48,42, 9,(21,8), 1,38, 64)
        , add_ip(9,1,[24])
        , srp0(24)
        , mdrpg(6)
        , srp0(38)
        , mdrp0rg(34)
        , bighead2(28,[60,54,26,36,4])
        , dx(26,8)
        , dx(36,-8)
        , f_dstr_dict({28:"9-4 ",34:"9+4 "})
        , ix()
        , dh1(18,31)
        , dh2(12)
        #y
        , sy()
        , mdapr(1)
        , alignrp(8)
        , tvtc2(18,[22,24,6,2,38])
        , alignrp(31)
        , head2(12,[39,45])
        , srp0(31)
        , bighead_stem_2(57)
        , mdrp0rg(51,"16+8 21-8 ")
        , mdrpb(4)
        , f_ip([26,36])
        , ud2(22)
        , iy()
        , dh1(15,28)
        , dh2(34)
        ),

    'uni0E2C':      #LO CHULA
        packline(""
        , tx2_1(62, 10,47,41, 4,(16,3), (20,1),37, 63)
        , add_ip(16,20,[2])
        , srp0(2)
        , mdrpg(18)
        , mdrpg(19)
        , srp0(20)
        , xhead1(26,59,53)
        , ix()
        , dh1(13,29)
        , dh2(7,23)
        #y
        , sy()
        , mdapr(1)
        , alignrp(3)
        , tvtc2(13,[2,17,18,19])
        , head2(7,[38,44])
        , ud1(2)
        , ud2(17)
        , srp0(17)
        , alignrp(20)
        , srp0(13)
        , mdrp0mrg(29)
        , head2(23,[50,56,32,37])
        , iy()
        , dh1(10,26)
        ),

    'uni0E2D':      #O ANG
        packline(""
        , tx2_2p(53, 3,15, 10,44,50, 22,37, 54, fround=70)
        , ip_round(53,15,30)
        , add_ip(30,37,[34,26])
        , ix()
        , dh1(7)
        , dh2(13)
        #y
        , sy()
        , mdapr(53)
        , tvtc2(34,[7,23,37])
        , tstemtc_2(26)
        , mdapr(7)
        , mdrpmrw(30)
        , head2(13,[41,47])
        , srp0(53)
        , tvbc(0)
        , tstemtc_1(19)
        , iy()
        , dh2(10)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , tx2_2p(68, 3,15, 10,49,55, 22,42, 69, fround=70)
        , srp0(3)
        , mdrp0rg(30)
        , tstemw_1(65)
        , add_ip(30,42,[33,62,58,27, 60,35,40,25])
        , ud1(60)
        , ud2(40)
        , ix()
        , dh1(7)
        , dh2(13)
        #y
        , sy()
        , mdapr(68)
        , tvtc2(33,[23,42], add1=mdrpmrg(38))
        , tstemtc_2m(62)
        , mdrp0mrw(58,"9+8 10+8 ")
        , 'RTDG'
        , headstem_2m(27)
        , 'RTG'
        , mdrp0mrw(7)
        , mdapr(7)
        , head2(13,[46,52])
        , add_ip(33,27,[35,60,40,25])
        , srp0(68)
        , tvbc(0)
        , tstemtc_1(19)
        , dx(25,8)
        , dx(35,-8)
        , iy()
        , dh2(10)
        ),

    'uni0E2F':      #PAIYAN NOI
        packline(""
        , tx2_0(35, 13,24, 1,34, 36, fstem='tstemtct')
        , add_ip(24,1,[18,31,33])
        , srp0(31)
        , mdrpg(6)
        , ix()  
        #, dh1(16)
        #y  
        , sy()
        , mdapr(1)
        , tvt2(34,[16])
        , mdapr(16)
        , tstemt_2(21)
        , mdrp0rg(10)
        , tstemtct_1(27)
        , iy()
        #, dh2(13)
        ),  

    'uni0E30':      #SARA A
        packline(""
        , srp0(66)
        , 'SROUND 70' , mdrp0rw(3) , 'RTG'
        , alignrp(36)
        , head1((9,42),[(30,63),(24,57),12,45])
        , mdapr(67)
        , mdrp0mrw(18)
        , alignrp(51)
        , ix()
        , dh1(39,6)
        , ud1(15)
        , srp0(15)
        , alignrp(48)
        #y  
        , sy()
        , mdapr(0)
        , tstemtc_1(14)
        , xhead2(6,27,21,dstr="")
        , mdrprg(18)
        #
        , mdapr(33)
        , tstemtc_1(47)
        , xhead2(39,60,54,dstr="")
        , mdrprg(51)
        , iy()
        , dh1(3,36)
        , dh2(9,42)
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdapr(9)
        , mdrprg(18)
        , head2(3,[30,24])
        , ud1(15)
        , ix()
        , dh1(6)
        #y  
        , sy()
        , tvtsara(0)
        , tstemtc_1(14)
        , xhead2(6,27,21,dstr="")
        , mdrprg(18)
        , iy()
        , dh1(3)
        , dh2(9)
        ),

    'uni0E32':    #SARA AA
        packline(""
        , tx1_0(18, 9, 1,16, 19)
        , add_ip(9,16,[13,5])
        , ix()
        #y
        , sy()
        , mdapr(1)
        , tvtc2(13,[9,2,16])
        , tstemtc_2(5)
        , mdapr(9)
        , iy()
        ),  

    'uni0E34':    #SARA I
        packline(""
        , h_sara_i(0,10,16,4)
        , ix()
        #y
        , sy()
        , v_sara_i(0,18,[16,10,4,2], 13,7)
        , iy()
        ),
    
    'uni0E35':    #SARA II
        packline(""
        , h_sara_i(0,14,20,4)
        , ip_round(4,0,12)
        , mdrpmrg(10)
        , ix()
        #y
        , sy()
        , v_sara_i(0,22,[20,14,4,2], 17,7)
        , mdrp0mrg(11)
        , add_ip(7,22,[9,12])
        , dx(9,-16)
        , iy()
        ),
    
    'uni0E36':    #SARA UE
        packline(""
        , h_sara_i(0,20,26,4)
        , srp0(0)
        , mdrp0mrg(15)
        , headsara2(9,[39,33,18])
        , dx(18,-8)
        , ix()
        #y
        , sy()
        , v_sara_i(0,28,[26,20,4,2], 23,7)
        , mdrp0mrg(12)
        , headsara2(18,[30,36,9])
        , dx(9,-8)
        , iy()
        ),

    'uni0E37':    #SARA UUE
        packline(""
        , h_sara_i(0,19,25,4)
        , ip_round(4,0,17)
        , mdrp0mrg(15)
        , mdrp0mrw(12)
        , mdrpmrg(10)
        , ix()
        #y  
        , sy()   
        , v_sara_i(0,27,[25,19,4,2], 22,7)
        , mdrp0mrg(11)
        , alignrp(16)
        , add_ip(7,2,[9,12,14,17])
        , ud2(14)
        , iy()
        ),  

    'uni0E38':    #SARA U
        packline(""
        , thbsara(13)
        , mdrpmrg(1)
        , mdrp0rg(7)
        , f_ip([23,17])
        , ix()
        #y  
        , sy()
        , mdapr(26) 
        , mdrp0mrw(10)
        , mdrp0rg(4)
        , f_ip([14,20])
        , mdrpmrg(1)
        , iy()
        ),  

    'uni0E39':    #SARA UU
        packline(""
        , thbsara(21)
        , mdrp0mrb(19)
        , mdrp0mrw(14)
#URS        , mdapr(13)
        , mdrpmrb(2)
        , mdrpmrg(8,"9-8 ")
        , f_ip([33,27])
        , ix() 
        #y  
        , sy()
        , mdapr(36)
        , mdrp0mrw(11)
        , mdrprg(21)
        , mdrp0rg(5)
        , f_ip([24,30])
        , mdrp0mrg(0)
        , mdrpmrb(17)
        , iy()
        ),

    'uni0E3A':    #PHINTHU
        packline(""
        , thbsara(9)
        , mdrpmrg(3)
        , ix() 
        #y  
        , sy()
        , mdapr(12)
        , mdrp0mrw(6)
        , mdrpmrg(0)
        , iy() 
        ),

    'uni0E3F':    #THAI CURRENCY SYMBOL BAHT
        packline(""
        , tx2_0(53, 5,(29,42), 35,22, 54)
        , serifw_2(3)
        , shprp2(7)
        , srp0(35)
        ,'RTDG' , mdrp0rg(48) ,'RTG'
        , tstemw_1(16)
        , iprs_middle_stem(29, (27,1,40,9),'headstem',(39,26,52,11), 48)
        , ix()
        #y  
        , sy()
        , mdapr(2)
        , alignrp(26)
        , mdrpmrg(1)
        , tstemt_1(27)
        , shprp2(5)
        , shprp2(31)
        , mdapr(9)
        , alignrp(12)
        , mdrpmrg(10)
        , tstemt_2(41)
        , shprp2(6)
        , shprp2(52)
        , iprs_middle_stem(41, (40,44),'tstemt',(28,39), 27)
        , f_ip([19])
        , iy()
        ),
#
    'uni0E40':    #SARA E
        packline(""
        , trs_e(3,5, 11,17,23, 27)
        , ix()
        , dh1(8)
        , dh11(1), dh12(13)
        #y  
        , sy()
        , mdapr(26)
        , tvt2(5)
        , tvbc(0)
        , head1(8,[14,20])
        , iy()
        , dh2(11)
        ),

    'uni0E42':    #SARA O
        packline(""
        , mdapr(7)
        , tstemtct_1(30)
        , mdrprg(19)
        , add_ip(7,19,[10,27,15,22])
        , trs_e(3,33, 39,45,51, 54)
        , ud2(30)
        , ix()
        , dh1(36)
        , dh11(1), dh12(41)
        #y  
        , sy()
        , mdapr(54)
        , tvbc(0)
        , head1(36,[42,48])
        #
        , mdapr(10)
        , v_top_ro_rua0(18, 27,22,15)
        , srp0(10)
        , mdrp0g(31)
        , f_ip([7,30])
        , mdrpg(6)
        , iy()   
        , dh2(35)
        ),

    'uni0E43':    #SARA AI MAI MUAN
        packline(""
        , trs_e(3,39, 45,51,57, 61)
        , mdapr(33)
        , mdrpb(10)
        , add_ip(10,4,[27])
        , srp0(27)
        , mdrpb(16)
        , ix()
        , dh1(42)
        , dh11(1), dh12(47)
        #y  
        , sy()
        , mdapr(60)
        , tvbc(0) 
        , head1(42,[48,54])
        #
        , mdapr(36)
        , tstemtct_2(7)
        , mdrp0rg(30)
        , mdrpb(13)
        , add_ip(7,13,[24,19])
        , iy()
        , dh2(27,45)
        ),

    'uni0E44':    #SARA AI MAIMALAI
        packline(""
        , trs_e(3,39, 45,51,57, 61)
        , mdapr(17)
        , mdrpmrg(25)
        , add_ip(25,3,[32])
        , srp0(32)
        , mdrpg(10)
        , ix()
        , dh1(42)
        , dh11(1), dh12(47)
        #y  
        , sy()
        , mdapr(60)
        , tvbc(0)
        , head1(42,[48,54])
        #
        , mdapr(36)
        , mdrpmrg(22)
        , tstemtc_2(7)
        , mdrp0rg(14)
        , tstemtc_1(29)
        , iy()
        , dh2(45)
        ),

    'uni0E45':    #LAKKHANGYAO
        packline(""
        , tx1(1,16, 19)
        , mdapr(9)
        , add_ip(9,16,[13,5])
        , ix()
        #y
        , sy()
        , mdapr(18)
        , tvtc2(13,[9,2,16])
        , tstemt_2(5)
        , mdapr(9)
        , srp0(18)
        , tvblu(1)
        , iy()
        ),

    'uni0E46':    #MAIYAMOK
        packline(""
        , tx2_0(39, 19,8, 1,25, 40)
        , head1(13,[36,30])
        , add_ip(19,25,[21,22,23,4,5,6])
        , ix()
        , dh1(10)
        , dh2(16)
        #y
        , sy()
        , mdapr(39)
        , tvtc2(23,[2,25])
        , alignrp(21)
        , tstemtct_2(4)
        , shprp2(6)
        , 'RTDG', mdrp0rg(5), 'RTG'
        , tstemtct_1(22)
        , mdrp0rg(8)
        , mdapr(8)
        , head2(16,[27,33])
        #
        , srp0(39)
        , tvblu(1)
        , iy()
        , dh2(13)
        ),

    'uni0E47':    #MAITAIKHU
        packline(""
        , mdapr(25)
        , mdrpg(19)
        , mdrp0rg(53)
        , 'RTDG',mdrprg(47),'RTG'
        , f_ip([65,59])
        , mdrp0rg(12)
        , f_ip([37,39,5,9])
        , mdrpg(32)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(9)
        , mdrpmb(35)
        , 'RTDG',mdrprg(50),'RTG'
        , f_ip([56,62,39,5,44])
        , srp0(39)
        , mdrp0mrw(28)
        , mdapr(28)
        , mdrp0mrb(16)
        , mdrpmrg(23)
        , iy()
        ),

    'uni0E47.high':    #MAITAIKHU
        packline(""
        , mdapr(24)
        , mdrpg(18)
        , mdrp0rg(52)
        , 'RTDG',mdrprg(46),'RTG'
        , f_ip([64,58])
        , mdrp0rg(11)
        , f_ip([34,38,5,9])
        , mdrpg(32)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(9)
        , mdrpg(34)
        , 'RTDG',mdrprg(49),'RTG'
        , f_ip([55,61,38,5,43])
        , mdrp0mrg(27)
        , mdrp0mg(15)
        , mdrpmrg(22)
        , iy()
        ),

    'uni0E48':    #MAI EK
        packline(""
        , mdapr(6)
        , mdrpmb(5)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrpmb(6)
        , iy()
        ),

    'uni0E48.low':    #MAI EK
        packline(""
        , thbsara(6)
        , mdrpmrb(5)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrpmb(6)
        , iy()
        ),

    'uni0E49':    #MAI THO
        packline(""
        , mdapr(14)
        , 'RTDG',mdrp0rg(8),'RTG'
        , f_ip([35,29,1,3,16])
        , srp0(14)
        , mdrp0mrw(19)
        , mdrp0mrg(23)
        , mdrpmb(19)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(5)
        , f_ip([1,16])
        , 'SROUND 70',mdrp0rg(11),'RTG'
        , f_ip([26,32])
        , mdrprg(21)
        , iy()
        ),

    'uni0E49.low':    #MAI THO
        packline(""
        , mdapr(14)
        , 'RTDG' , mdrp0rg(8) , 'RTG'
        , f_ip([35,29,1,3,16])
        , srp0(14)
        , mdrp0mrw(19)
        , mdrp0mrg(23)
        , mdrpmb(19)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrp0rg(5)
        , f_ip([1,16])
        , 'SROUND 70',mdrp0rg(11),'RTG'
        , f_ip([26,32])
        , mdrprg(21)
        , iy()
        ),

    'uni0E4A':    #MAI TRI
        packline(""
        , mdapr(31)
        , mdrpb(4)
        , mdrp0rg(47)
        , mdrpb(37)
        , srp0(31)
        , mdrp0rg(23)
        , f_ip([26,27,28,7,8,9])
        , mdrpb(12)
        , 'RDTG',mdrp0rg(17),'RTG'
        , f_ip([59,53])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(20)
        , mdrpb(34)
        , 'RDTG',mdrprg(14),'RTG'
        , f_ip([50,56,12])
        , mdrp0rg(28)
        , alignrp(26)
        , mdrpmrg(44)
        , mdrpg(8)
        , f_ip([9,7,27])
        , iy()
        ),

    'uni0E4A.low':    #MAI TRI
        packline(""
        , thbsara(31)
        , mdrpb(4)
        , mdrp0rg(47)
        , mdrpb(37)
        , srp0(31)
        , mdrp0rg(23)
        , f_ip([26,27,28,7,8,9])
        , mdrpb(12)
        , 'RDTG',mdrp0rg(17),'RTG'
        , f_ip([59,53])
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(20)
        , mdrpb(34)
        , 'RDTG',mdrprg(14),'RTG'
        , f_ip([50,56,12])
        , mdrp0rg(28)
        , alignrp(26)
        , mdrpmrg(44)
        , mdrpg(8)
        , f_ip([9,7,27])
        , iy()
        ),

    'uni0E4B':    #MAI CHATTAWA
       packline(""
        , mdapr(10)
        , mdrp0mrg(7)
        , mdrpmg(10)
        , 'RTDG',mdrp0mrb(6),'RTG'
        , f_ip([5,2,1,8,11,0])
        , mdrpmg(3)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(11)
        , alignrp(2)
        , mdrpmg(0)
        , 'RTDG',mdrp0mrb(8),'RTG'
        , alignrp(5)
        , mdrpmg(7)
        , iy()
        ),

    'uni0E4B.low':    #MAI CHATTAWA
        packline(""
        , thbsara(10)
        , mdrp0mrg(7)
        , mdrpmg(10)
        , 'RTDG',mdrp0mrb(6),'RTG'
        , f_ip([5,2,1,8,11,0])
        , mdrpmg(3)
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0mrg(11)
        , alignrp(2)
        , mdrpmg(0)
        , 'RTDG',mdrp0mrb(8),'RTG'
        , alignrp(5)
        , mdrpmg(7)
        , iy()
        ),

    'uni0E4C':    #THANTHAKAT
        packline(""
        , mdapr(18)
        , mdrpmrg(3), f_ip([30,24,16])
        , mdrp0rg(13)
        , mdrpg(10)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(7), f_ip([21,27])
        , mdrpmrg(10)
        , mdrpmg(16)
        , iy()
        ),

    'uni0E4C.low':    #THANTHAKAT
        packline(""
        , mdapr(19)
        , mdrpmrg(3), f_ip([31,25,17])
        , mdrp0rg(14)
        , mdrpb(11)
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0mrg(7), f_ip([22,28])
        , mdrpmrg(11)
        , mdrpmb(17)
        , iy()
        ),

    'uni0E4D':    #NIKHAHIT
        packline(""
        , mdapr(9)
        , head2(3,[21,15])
        , f_dstr(3,"9-8 ")
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , head1(6,[12,18])
        , f_dstr(6,"9+8 ")
        , iy()
        ),

    'uni0E4D.high':    #NIKHAHIT
        packline(""
        , mdapr(9)
        , mdrprg(3)
        , f_ip([21,15])
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrprg(6)
        , f_ip([12,18])
        , iy()
        ),

    'uni0E4E':    #YAMAKKAN
        packline(""
        , thbsara(17)
        , mdrpg(22)
        , mdrp0rg(11)
        , f_ip([9,34])
        , mdrpmb(28)
        , mdrp0rg(3)
        , mdrpmb(46)
        , ix()
        #
        , sy()
        , tvtsara(0)
        , mdrpmb(49)
        , mdrp0rg(6)
        , mdrpmb(43)
        , mdrp0rg(14)
        , mdrpmb(25)
        , iy()
        ),

    'uni0E4F':    #FONGMAN
        packline(""
        , mdapr(49) 
        , mdrp0mrw(9)
        , mdrp0mrb(15)
        , mdrpmrw(33)
        , srp0(9)
        , mdrp0rg(3)
        , mdrp0mrb(21)
        , mdrpmrw(27)
        , add_ip(27,33,[45,39])
        , ix()
        #y  
        , sy()
        , mdapr(0) 
        , mdrp0mrb(12)
        , mdrpmrw(24)
        , srp0(0)
        , mdrp0rg(6)
        , mdrp0mrb(18)
        , mdrpmrw(30)
        , add_ip(30,24,[36,42])
        , iy()
        ),

    'uni0E50':    #THAI DIGIT ZERO
        packline(""
        , txus2_0(24, 3,21, 15,9, 25, fstem='tnumstemw',rstem='tnumstemw')
        , ix()
        #y  
        , sy()
        , mdapr(24)
        , tvtnc(6)
        , tnumstemt_2(18)
        , srp0(24)
        , tvbc(0)
        , tnumstemt_1(12)
        , iy()
        ),

    'uni0E51':    #THAI DIGIT ONE
        packline(""
        , txus2_0(48, 3,28, 22,9, 49, fstem='tnumstem166',rstem='tnumstem166')
        , 'RDTG',ip_round(28,9,45),'RTG'
        , tnumstemtc_2(34)
        , mdrprg(17)
        , mdrprg(39)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , tnumstemtc_1(31)
        , mdrp0g(20)
        , mdrpg(14)
        , srp0(0)
        , tvtnc(6)
        , tnumstemw_2(25)
        , 'RDTG',ip_round(6,31,42),'RTG'
        , tnumheaddia_2(36)
        , iy()
        ),

    'uni0E52':    #THAI DIGIT TWO
        packline(""
        , txus2_0(80, 4,14, 22,77, 81, fstem='tnumstemw', rstem='tnumstem166')
        , srp0(14)
        , mdrp0mrw(67)
        , mdapr(67)
        , tnumstemtc_1(49)
        , ipus_middle_stem(49, 43,'tnumstemt',30, 22, dsm="12-8 13-8 14-8 15-8 ")
        , f_ip([73,27])
#        , ip_round(49,43,61)
, mdrp0mrw(61)
        , tnumheaddia_2(55)
        , ix()
        #y  
        , sy()
        , mdapr(0)
        , tnumstemt_1(19)
        , tvtnc(74)
        , alignrp(70)
        , mdrpmrg(11)
        , tnumstemw_2(25)
        , shprp2(46)
        , srp0(19)
        , mdrp0mrw(64)
        , alignrp(35)
        , tnumstemtc_1(52)
        , mdrprb(58)
        , iy()
        ),

    'uni0E53':    #THAI DIGIT THREE
        packline(""
        , txus2_0(73, 3,56, 29,15, 74, fstem='tnumstem166',rstem='tnumstem166', dsf="", dsr="16+8 ")
        , ipus_middle_stem(56, 50,'tnumstemt',36, 29)
        , f_ip([9,34])
        , ip_round(56,50,70)
        , tnumheaddia_2(64)
        , f_ip([61])
        , ix()
        #y  
        , sy()
        , mdapr(73)
        , tvtnc(6,[3,57,50,36,29,15,9,34])
        , alignrp(12)
        , tnumstemw_2(53)
        , shprp2(32)
        , srp0(73)
        , tvbc(0)
        , alignrp(42)
        , alignrp(20)
        , tnumstemtc_1(58)
        , mdrprg(67)
        , f_ip([61])
        , iy()
        ),

    'uni0E54':    #THAI DIGIT FOUR
        packline(""
        , txus2_0(64, 13,34, 20,27, 65, fstem='tnumstemw',rstem='tnumstemw')
        , ip_round(34,27,62)
        , ipus_middle_stem(34, 42,'tnumstemt',59, 62)
        , ip_round(59,62,54)
        , tnumheaddia_1(48)
        , add_ip(59,62,[39,61,5])
        , ix()
        #y  
        , sy()
        , mdapr(64)
        , tvtn(17,[13,34])
        , mdrprg(24)
        , tstemt_2m(30)
        , mdrp0mrw(45)
        , tnumheaddia_2(51)
        , f_ip([42,59,56])
        , srp0(64)
        , tvbc(0)
        , alignrp(10)
        , tnumstem166_1(62)
        , tnumstemt_1(37)
        , iy()
        ),

    'uni0E55':    #THAI DIGIT FIVE
        packline(""
        , txus2_0(91, 13,49, 31,38, 92, fstem='tnumstemw',rstem='tnumstemw')
        , ip_round(49,38,78)
        , ipus_middle_stem(49, 57,'tnumstemt',74, 77)
        , ip_round(74,77,69)
        , tnumheaddia_1(63)
        , ip_round(49,31,25)
        , head2(19,[88,82,16,28,43])
        , add_ip(74,77,[54,76,5])
        , ix()
        #y  
        , sy()
        , mdapr(91)
        , tvtn(17,[13,49])
        , mdrprg(35)
        , tstemt_2m(45)
        , mdrp0mrw(60)
        , tnumheaddia_2(66)
        , f_ip([57,74,71])
        , srp0(91)
        , tvbc(0)
        , alignrp(10)
        , tnumstem166_1(77)
        , tnumstemt_1(52)
        , ip_round(35,17,22)
        , xhead0(85,79,direction='-')
        , add_ip(22,45,[16,17,28,43])
        , iy()
        ),

    'uni0E56':    #THAI DIGIT SIX
        packline(""
        , txus2_0(62, 37,51, 20,59, 63, fstem='tnumstemt',rstem='tnumstemw')
        , ip_round(62,37,43)
        , tnumstemt_1(48)
        , srp0(37)
        , mdrp0rg(3)
        , mdrprb(9)
        , f_ip([15])
        , ix()
        #y  
        , sy()
        , mdapr(62)
        , tvtnc(56,[21,59,29])
        , tnumstem166_2(23)
        , mdrp0rg(46)
        , tnumstem166_2(40)
        , mdapr(29)
        , mdrpb(53)
        , mdrp0mrw(6)
        , tnumheaddia_2(12)
        , f_ip([15])
        , srp0(62)
        , tvbc(0)
        , tnumstemt_1(18)
        , iy()
        ),

    'uni0E57':    #THAI DIGIT SEVEN
        packline(""
        , txus2_0(83, 49,31, 67,78, 84, fstem='tnumstem166',rstem='tnumstem166')
        , ipus_middle_stem(31, 9,'tnumstemt',61, 67)
        , mdrpg(3)
        , ipus_middle_stem(31, 25,'tnumstemt',16, 9)
        , f_ip([55,14])
        , 'RDTG',ip_round(31,3,43),'RTG'
        , tnumheaddia_2(37)
        , srp0(67)
        , mdrp0rg(72)
        , mdrpg(75)
        , ix()
        #y  
        , sy()
        , mdapr(83)
        , tvtnc(58,[49,31,55,14,9,61,67,78])
        , alignrp(52)
        , mdrprg(75)
        , tnumstemw_2(12)
        , shprp2(28)
        , srp0(83)
        , tvbc(46)
        , alignrp(0)
        , tnumstemt_1(6)
        , tnumstemtc_1(34)
        , mdrp0rg(40)
        , mdrpmrw(21)
        , iy()
        ),

    'uni0E58':    #THAI DIGIT EIGHT
        packline(""
        , txus2_0(73, 13,43, 24,32, 74, fstem='tnumstem166',rstem='tnumstemw')
        , srp0(24)
        , mdrp0rg(70)
        , mdrprg(64)
        , f_ip([59])
        , add_ip(43,24,[16,40,21,35])
        , add_ip(43,70,[46,51,10,5,56,0])
        , ix()  
        #y  
        , sy()
        , mdapr(73)
        , tvtnc(16,[13,43])
        , mdrprg(29)
        , tnumstemw_2(40)
        , mdrp0g(21)
        , mdrpg(35)
        , srp0(73)
        , tvbc(10)
        , alignrp(0)
        , tnumstemw_1(46)
        , mdrp0rg(51)
        , tnumstem166_2(5)
        , srp0(0)
        , tnumstemtc_1(56)
        , ip_round(35,0,67)
        , tnumheaddia_2(61)
        , iy()
        ),

    'uni0E59':    #THAI DIGIT NINE
        packline(""
        , txus2_0(78, 3,58, 20,28, 79, fstem='tnumstemw',rstem='tnumstemw')
        , srp0(20)
        , mdrprg(47)
        , mdrp0rg(75)
        , mdrprg(69)
        , f_ip([64])
        , srp0(3)
        , mdrp0rg(9)
        , tnumstemw_1(39)
        , f_ip([6])
        , ix()  
        #y  
        , sy()
        , mdapr(12,"10+8 16+8 17+8 18+8 ")
        , mdrprg(25)
        , tnumstem166_2(36)
        , mdrp0g(17)
        , mdrpg(31)
        , mdapr(78)
        , tvbc(0)
        , tnumstem166_1(61)
        , ipus_middle_stem(12, 45,'tnumstemw',50, 61, dsm="9-8 ")
        , f_ip([6])
        , 'RDTG',ip_round(50,61,72,"9+4 "),'RTG'
        , tnumheaddia_2(66)
        , iy()
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , tx2_0(44, 12,23, 38,36, 45, fstem='tstemtct')
        , srp0(38)
        , mdrp0mrw(43)
        , alignrp(32)
        , tstemw_2(1)
        , add_ip(23,1,[6])
        , srp0(6)
        , mdrpb(28)
        , ix()
        #y  
        , sy()
        , mdapr(1)
        , alignrp(38)
        , tvt2m(32,[15,29,43])
        , shprp2(36)
        , tstemtct_2(4)
        , shprp2(41)
        , mdapr(15)
        , tstemt_2(20)
        , mdrp0rg(9)
        , tstemt_1(26)
        , srp0(29)
        , mdrpg(7)
        , iy()
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , tx2_0(99, 3,27, 51,67, 100, fstem='tstemtct',rstem='tstemtct')
        , srp0(27)
        , mdrp0mrw(15)
        , xhead0(96,90)
        , mdrp0rg(9)
        , tstemtc_2(21)
        , mdrpmrw(33)
        , add_ip(33,51,[35,38,41,44,47,48,83,80,77,74,71,70])
        , add_ip(3,9,[6,24])
        , add_ip(3,33,[30,0])
        , ix()
        , dh1(18)
        , dh2(12)
        #y  
        , sy()
        , mdapr(6)
        , tstemtct_2(24)
        , mdapr(0)
        , tstemtct_1m(30)
        , mdrp0mrw(12) 
        , head1(18,[87,93])
        , add_ip(6,0,[35,38,41,44, 81,78,75, 36,39,42, 83,80,77, 47])
        , mdapr(47)
        , tstemtct_2(71)
        , iy()
        , dh1(15)
        ),

    }



#++++++++++++++++++++++++++++++

#----- MODIFY pseudo_code_dict BY -----------
#----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#----- TO REAL pseudo_code ------------------
from dttcmd import *

self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)
